/***********
* dataflow *
************

Copies lattice data in and out.
*/

#include "comext.h"
#include <stdio.h>

char backname[128];
char seedname[128], ptsname[128];

backup(spin)
short spin[IMAX][JMAX];
{
FILE *fb,*fopen();

  sprintf(backname, "back.%s", fname);
  if ((fb=fopen(backname,"w")) == NULL) {
     perror("backup") ;
     exit( -1 ) ;
  }
  putdata(fb,spin) ; 
  fclose(fb) ;
}


putdata(fd,spin)
FILE *fd;
short spin[IMAX][JMAX];
{
	int ret,i;

	/* Back up the spin configuration */
	for (i=0;i<isiz;i++) {
	   cfwrite(&spin[i][0],sizeof(short),jsiz,fd);
	}
	cfwrite(&beta,sizeof(float),1,fd);
	cfwrite(&totswps,sizeof(int),1,fd);

	/* Back up the seeds and pointers for the random number generator */
	cfwrite(&randx,sizeof(long),1,fd);
        sprintf(seedname, "seeds.%s", fname);
        sprintf(ptsname,  "pts.%s",   fname);
	write_seeds(seedname,ptsname);

	return 0 ;
}

getdata(fd,spin)
FILE *fd;
short spin[IMAX][JMAX];
{
	int ret,i,j;
	float oldbeta;
        int numbad;
        short badspin;
	long oldrand;

	/* Read in the spin configuration */
	for (i=0;i<isiz;i++) {
	    if((ret=fread(&spin[i][0],sizeof(short),jsiz,fd)) != jsiz) {
	        perror("spin read") ; exit(-2) ;
	    }
	}
	if((ret=fread(&oldbeta,sizeof(float),1,fd)) != 1) {
	        perror("read") ; exit(-2) ;
	}
	if((ret=fread(&totswps,sizeof(int),1,fd)) != 1) {
	        perror("read") ; exit(-2) ;
	}
	if((ret=fread(&oldrand,sizeof(long),1,fd)) != 1) {
	        perror("read") ; exit(-2) ;
	}
	/* Check that the spins are sensible */
        numbad = 0;
        for(i=0;i<isiz;i++)
           for(j=0;j<jsiz;j++)
              if ((spin[i][j] >= Q) || (spin[i][j] < 0)) {
                 badspin = spin[i][j];
                 numbad++;
              }
        if (numbad > 0) {
           printf("There are %d bad spins such as %d!!\n", numbad,badspin);
        }

	/* Set up the random number seeds and pointers */
	if (first == 2) {
          init_seeds();
        }
	else {
           sprintf(seedname, "seeds.%s", lastfname);
           sprintf(ptsname,  "pts.%s",   lastfname);
	   read_seeds(seedname,ptsname);
	}

	printf("totswps so far: %d\n", totswps);
	if (beta != oldbeta) {
	   printf("WARNING - beta (%f) != oldbeta (%f)\n", beta, oldbeta);
	   printf("totswps set to zero.\n");
	   totswps = 0;
        }
	fflush(stdout);

	return 0 ;
}

